# Generated by Django 4.1.5 on 2023-04-27 13:34

from django.conf import settings
from django.db import migrations, models
import django.db.models.deletion
import django.utils.timezone


class Migration(migrations.Migration):

    initial = True

    dependencies = [
        migrations.swappable_dependency(settings.AUTH_USER_MODEL),
        ("metadata", "0003_database_url_test"),
        ("contenttypes", "0002_remove_content_type_name"),
    ]

    operations = [
        migrations.CreateModel(
            name="Submission",
            fields=[
                (
                    "id",
                    models.BigAutoField(
                        auto_created=True,
                        primary_key=True,
                        serialize=False,
                        verbose_name="ID",
                    ),
                ),
                ("object_id", models.TextField()),
                (
                    "status",
                    models.CharField(
                        choices=[("pending", "pending"), ("submitted", "submitted")],
                        default="",
                        max_length=100,
                    ),
                ),
                (
                    "date_pending",
                    models.DateTimeField(
                        default=django.utils.timezone.now, help_text="Pending date"
                    ),
                ),
                (
                    "creation_pending",
                    models.DateTimeField(
                        default=django.utils.timezone.now, help_text="Created date"
                    ),
                ),
                (
                    "submission_date",
                    models.DateTimeField(
                        blank=True, default=None, help_text="Submission date", null=True
                    ),
                ),
                (
                    "external_id",
                    models.TextField(blank=True, help_text="External ID", null=True),
                ),
                (
                    "assigned_to",
                    models.ForeignKey(
                        blank=True,
                        help_text="Data submitter",
                        null=True,
                        on_delete=django.db.models.deletion.CASCADE,
                        related_name="assigned_to",
                        to=settings.AUTH_USER_MODEL,
                    ),
                ),
                (
                    "content_type",
                    models.ForeignKey(
                        on_delete=django.db.models.deletion.CASCADE,
                        related_name="content_type_submission_status",
                        to="contenttypes.contenttype",
                    ),
                ),
                (
                    "db",
                    models.ForeignKey(
                        on_delete=django.db.models.deletion.CASCADE,
                        to="metadata.database",
                    ),
                ),
            ],
        ),
        migrations.CreateModel(
            name="SubmissionMessage",
            fields=[
                (
                    "id",
                    models.BigAutoField(
                        auto_created=True,
                        primary_key=True,
                        serialize=False,
                        verbose_name="ID",
                    ),
                ),
                (
                    "date",
                    models.DateTimeField(
                        default=django.utils.timezone.now,
                        help_text="Date du commentaire",
                    ),
                ),
                (
                    "message",
                    models.JSONField(
                        blank=True, help_text="Project notepad", null=True
                    ),
                ),
                (
                    "message_type",
                    models.CharField(
                        choices=[
                            ("comment", "comment"),
                            ("create", "create"),
                            ("open", "open"),
                            ("close", "close"),
                            ("assign", "assign"),
                            ("submission", "submission"),
                            ("submission_results", "submission_results"),
                            ("modification", "modification"),
                        ],
                        default="",
                        max_length=200,
                    ),
                ),
                (
                    "message_by",
                    models.ForeignKey(
                        blank=True,
                        help_text="Commentator",
                        null=True,
                        on_delete=django.db.models.deletion.CASCADE,
                        to=settings.AUTH_USER_MODEL,
                    ),
                ),
                (
                    "sub",
                    models.ForeignKey(
                        on_delete=django.db.models.deletion.CASCADE,
                        to="data_brokering.submission",
                    ),
                ),
            ],
        ),
        migrations.CreateModel(
            name="ExternalID",
            fields=[
                (
                    "id",
                    models.BigAutoField(
                        auto_created=True,
                        primary_key=True,
                        serialize=False,
                        verbose_name="ID",
                    ),
                ),
                ("object_id", models.TextField()),
                (
                    "external_id",
                    models.JSONField(blank=True, help_text="External ID", null=True),
                ),
                (
                    "content_type",
                    models.ForeignKey(
                        on_delete=django.db.models.deletion.CASCADE,
                        related_name="content_type_external_id",
                        to="contenttypes.contenttype",
                    ),
                ),
                (
                    "db",
                    models.ForeignKey(
                        on_delete=django.db.models.deletion.CASCADE,
                        to="metadata.database",
                    ),
                ),
            ],
        ),
        migrations.AddIndex(
            model_name="submission",
            index=models.Index(
                fields=["content_type", "object_id"],
                name="data_broker_content_907d50_idx",
            ),
        ),
        migrations.AddIndex(
            model_name="externalid",
            index=models.Index(
                fields=["content_type", "object_id"],
                name="data_broker_content_fefec7_idx",
            ),
        ),
    ]
